---
title: Provisioning
url: https://docs.vultr.com/products/orchestration/isos/provisioning
description: The process of setting up and configuring a new server or service to make it ready for use.
publish_date: 2024-09-23T20:21:18.197591Z
last_updated: 2025-09-29T04:48:36.198342Z
---

# How to Manage ISO Images for Vultr Instances

ISO Images for Vultr instances are compressed copies of an operating system's installer. These images allow you to install custom operating systems on Cloud Compute instances. The ISO files may contain pre-configured settings and software according to specific needs to streamline server setup. The Vultr library also allows you to choose and install various public standard ISOs including Finnix, GParted, Hiren's BootCD PE, and SystemRescue.

Follow this guide to manage ISO Images for Vultr instances using the Vultr Console, API, CLI, or Terraform.

=== "Vultr Console"

    1. Navigate to **Products** and select **Orchestration**. Then, choose **ISOs**.
    1. Click **Add ISO**.
    1. Enter the remote URL of your ISO file and click **Upload**.

=== "Vultr API"

    1. Send a `POST` request to the [**Create ISO** endpoint](https://www.vultr.com/api/#tag/iso/operation/create-iso) and specify the remote ISO file URL.

        ```console
        $ curl "https://api.vultr.com/v2/iso" \
            -X POST \
            -H "Authorization: Bearer ${VULTR_API_KEY}" \
            -H "Content-Type: application/json" \
            --data '{
                "url" : "https://example.com/remote_iso_file_url.iso"
            }'
        ```

        Visit the [**Create ISO** endpoint](https://www.vultr.com/api/#tag/iso/operation/create-iso) to view additional attributes to add to your request.

    1. Send a `GET` request to the [**List ISOs** endpoint](https://www.vultr.com/api/#tag/iso/operation/list-isos) to list all ISOs.

        ```console
        $ curl "https://api.vultr.com/v2/iso" \
            -X GET \
            -H "Authorization: Bearer ${VULTR_API_KEY}"
        ```

=== "Vultr CLI"

    1. Create an ISO from an URL by defining the URL where you want to download the ISO file.

        ```console
        $ vultr-cli iso create --url https://releases.ubuntu.com/24.04/ubuntu-24.04-live-server-amd64.iso
        ```

    1. List all ISOs.

        ```console
        $ vultr-cli iso list
        ```

    1. List specific details about an ISO by specifying the ISO ID.

        ```console
        $ vultr-cli iso get iso_id
        ```
    
        Run `vultr-cli iso create --help` to view all options.

=== "Terraform"

    1. Define a custom ISO by URL and apply.

        ```terraform
        resource "vultr_iso" "custom_iso" {
            url = "https://example.com/remote_iso_file_url.iso"
        }
        ```

    1. Attach the ISO when creating an instance. Remember to set `os_id = 159` for custom ISO boot.

        ```terraform
        resource "vultr_instance" "server" {
            region = "ewr"
            plan   = "vc2-2c-4gb"
            label  = "iso-boot"

            os_id = 159          # required for custom ISO
            iso_id = vultr_iso.custom_iso.id
        }
        ```

    1. Apply the configuration and observe the following output:

        ```
        Apply complete! Resources: 2 added, 0 changed, 0 destroyed.
        ```
